// Plugin.cpp : Implementation of CPlugin

#include "stdafx.h"
#include "Plugin.h"


// CPlugin

STDMETHODIMP CPlugin::SetSite(IUnknown *pUnkSite)
{
    if (pUnkSite != NULL)
    {
        CComQIPtr<IServiceProvider> sp = pUnkSite;
        HRESULT hr = sp->QueryService(IID_IWebBrowserApp,
            IID_IWebBrowser2, (void**)&m_spWebBrowser);
        hr = sp->QueryInterface(IID_IOleCommandTarget,
            (void**)&m_spTarget);
    }
    else
    { 
        m_spWebBrowser.Release();
        m_spTarget.Release();
    }
    return IObjectWithSiteImpl<CPlugin>::SetSite(pUnkSite);
}

STDMETHODIMP CPlugin::Exec(
    const GUID *pguidCmdGroup, DWORD nCmdID,
    DWORD nCmdExecOpt, VARIANTARG *pvaIn, VARIANTARG *pvaOut)
{
    MessageBox(NULL, _T("Hello, World!"), _T("Greetings"), 0);
    return S_OK;
}
STDMETHODIMP CPlugin::QueryStatus(
    const GUID* pguidCmdGroup, ULONG cCmds,
    OLECMD prgCmds[], OLECMDTEXT* pCmdText)
{
    int i;
    for (i=0; i<((int) cCmds); i++)
        prgCmds[i].cmdf = OLECMDF_SUPPORTED | OLECMDF_ENABLED;
    return  S_OK;
}