// Plugin.h : Declaration of the CPlugin

#pragma once
#include "resource.h"       // main symbols
#include <ShlGuid.h>
#include <MsHTML.h>
#include "MyPlugins.h"


#if defined(_WIN32_WCE) && !defined(_CE_DCOM) && !defined(_CE_ALLOW_SINGLE_THREADED_OBJECTS_IN_MTA)
#error "Single-threaded COM objects are not properly supported on Windows CE platform, such as the Windows Mobile platforms that do not include full DCOM support. Define _CE_ALLOW_SINGLE_THREADED_OBJECTS_IN_MTA to force ATL to support creating single-thread COM object's and allow use of it's single-threaded COM object implementations. The threading model in your rgs file was set to 'Free' as that is the only threading model supported in non DCOM Windows CE platforms."
#endif



// CPlugin

class ATL_NO_VTABLE CPlugin :
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CPlugin, &CLSID_Plugin>,
	public IObjectWithSiteImpl<CPlugin>,
	public IDispatchImpl<IPlugin, &IID_IPlugin, &LIBID_MyPluginsLib, /*wMajor =*/ 1, /*wMinor =*/ 0>,
	public IOleCommandTarget
{
public:
	CPlugin()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_PLUGIN)

DECLARE_NOT_AGGREGATABLE(CPlugin)

BEGIN_COM_MAP(CPlugin)
	COM_INTERFACE_ENTRY(IPlugin)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IObjectWithSite)
	COM_INTERFACE_ENTRY(IOleCommandTarget)

END_COM_MAP()



	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}

	void FinalRelease()
	{
	}

public:
    STDMETHOD(SetSite)(IUnknown *pUnkSite);
    STDMETHOD(Exec)(const GUID *pguidCmdGroup, DWORD nCmdID,
        DWORD nCmdExecOpt, VARIANTARG *pvaIn, VARIANTARG *pvaOut);
    STDMETHOD(QueryStatus)(const GUID *pguidCmdGroup, ULONG cCmds,
        OLECMD *prgCmds, OLECMDTEXT *pCmdText);
private:
    void GenerateReport(BSTR filename);
    BSTR GenerateReportStylesheet();
    BSTR DoImageReport(IHTMLDocument2* pDocument);
 
private:
    CComPtr<IWebBrowser2> m_spWebBrowser;
    CComQIPtr<IOleCommandTarget, &IID_IOleCommandTarget> m_spTarget;
public:

};

OBJECT_ENTRY_AUTO(__uuidof(Plugin), CPlugin)
